﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;
using System.IO;

namespace ReflectionConsoleApplication
{
    class Program
    {
        static void Main(string[] args)
        {
            String targetAssemblyStr = "ClassLibrary1";
            String targetAssemblySymbol = "Class1";
            String targetAssemblyMethod = "dumpPlatformDetails";

            Person person = new Person("Stephen");

			Console.WriteLine("Person class type: {0}", person.GetType());
			AncillaryClass ancillary = new AncillaryClass();
            Console.WriteLine("AncillaryClass type: {0}", ancillary.GetType());
			IMyBaseInterface iMyBaseInterface;
            iMyBaseInterface = ancillary;
            Console.WriteLine();
            Console.WriteLine("iMyBaseInterface type: {0}", iMyBaseInterface.GetType());
            Console.WriteLine("iMyBaseInterface.GetType().IsClass: {0}", iMyBaseInterface.GetType().IsClass);

            MethodInfo[] methodInfo = ancillary.GetType().GetMethods();
            foreach (MethodInfo mi in methodInfo)
                Console.WriteLine("Method name: {0}", mi.Name);

            Console.WriteLine();

            Type[] interfaceInfo = ancillary.GetType().GetInterfaces();
            foreach (Type t in interfaceInfo)
                Console.WriteLine("Interface name: {0}", t.Name);

            AnotherClass anotherClass = new AnotherClass();
            Console.WriteLine("anotherClass.GetType().IsAbstract: {0}", anotherClass.GetType().IsAbstract);

            Assembly assembly = null;
            try
            {
                assembly = Assembly.Load(targetAssemblyStr);
            }
            catch (FileNotFoundException e)
            {
                Console.WriteLine("Exception {0} ", e.Message);
            }

            Type anExtractedType = assembly.GetType(targetAssemblyStr + "." + targetAssemblySymbol);
            object reconstitutedObject = Activator.CreateInstance(anExtractedType);
            MethodInfo methodInfo1 = anExtractedType.GetMethod(targetAssemblyMethod);

            anExtractedType.GetGenericArguments();

            methodInfo1.Invoke(reconstitutedObject, null);
            Console.WriteLine("ReconstitutedObject object type: {0}", reconstitutedObject.GetType());

            Console.ReadLine();
		}
    }
}
